
; CC5X Version 3.0, Copyright (c) B. Knudsen Data
; C compiler for the PICmicro family
; ************  28. Feb 2000  14:42  *************

	processor  16F84A
	radix  DEC

TMR0        EQU   0x01
OPTION_REG  EQU   0x81
PCL         EQU   0x02
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
tempo       EQU   0x0E
nx1seg      EQU   0x0F
var1seg     EQU   0x10
estado      EQU   0x0C
tempo_2     EQU   0x0D

	GOTO main

  ; FILE C:\KITPIC\EXEMPLOS\SEMAF0\SEMAFORO.C
			;#include <16f84A.h>
			;
			;#define T1SEG 20
			;#define T50MSEG 256-195
			;
			;char get_led(char W)
			;{
get_led
			;    skip(W);
	CLRF  PCLATH
	ADDWF PCL,1
			;#pragma return[4] = 0b.0010.0001 0b.0001.0100 0b.0001.0010 0b0100.0001
	RETLW .33
	RETLW .20
	RETLW .18
	RETLW .65
			;}
			;
			;char get_time(char W)
			;{
get_time
			;    skip(W);
	CLRF  PCLATH
	ADDWF PCL,1
			;#pragma return[4] = 1 4 1 2
	RETLW .1
	RETLW .4
	RETLW .1
	RETLW .2
			;}
			;
			;void wait_time(char tempo)
			;{
wait_time
	MOVWF tempo
			;    char nx1seg;
			;    char var1seg;
			;
			;    for (nx1seg = 0; nx1seg < tempo; nx1seg++)
	CLRF  nx1seg
m001	MOVF  tempo,W
	SUBWF nx1seg,W
	BTFSC 0x03,Carry
	GOTO  m005
			;    {
			;        for (var1seg = 0; var1seg < T1SEG; var1seg++)
	CLRF  var1seg
m002	MOVLW .20
	SUBWF var1seg,W
	BTFSC 0x03,Carry
	GOTO  m004
			;        {
			;             TMR0 = T50MSEG;
	MOVLW .61
	BCF   0x03,RP0
	MOVWF TMR0
			;             while (TMR0 != 0);
m003	BCF   0x03,RP0
	MOVF  TMR0,W
	BTFSS 0x03,Zero_
	GOTO  m003
			;        }
	INCF  var1seg,1
	GOTO  m002
			;    }
m004	INCF  nx1seg,1
	GOTO  m001
			;}
m005	RETURN
			;
			;void main(void)
			;{
main
			;    char estado, tempo;
			;
			;    PORTA = 0b.0000.0000;  
	BCF   0x03,RP0
	CLRF  PORTA
			;    TRISA = 0b.1111.1111;  
	MOVLW .255
	BSF   0x03,RP0
	MOVWF TRISA
			;    PORTB = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTB
			;    TRISB = 0b.0000.0000;
	BSF   0x03,RP0
	CLRF  TRISB
			;    OPTION = 0x07;
	MOVLW .7
	MOVWF OPTION_REG
			;    TMR0 = 0x00;
	BCF   0x03,RP0
	CLRF  TMR0
			;    estado = 0;
	CLRF  estado
			;
			;    for (;;) {
			;	PORTB = get_led(estado);
m006	MOVF  estado,W
	CALL  get_led
	BCF   0x03,RP0
	MOVWF PORTB
			;	tempo = get_time(estado); 
	MOVF  estado,W
	CALL  get_time
	MOVWF tempo_2
			;	wait_time(tempo); 
	MOVF  tempo_2,W
	CALL  wait_time
			;        estado++;
	INCF  estado,1
			;        if (estado > 3) estado = 0;
	MOVLW .4
	SUBWF estado,W
	BTFSS 0x03,Carry
	GOTO  m006
	CLRF  estado
			;    }	
	GOTO  m006
			;}

	END
